
public class MergeSort<T extends Comparable <? super T>> implements SortInterface<T> {

	@Override
	public void sort(T[] arrayToSort) {
		Object[] tempArray = new Object[arrayToSort.length];
		mergeSort(arrayToSort, tempArray, 0, arrayToSort.length-1);
		
	}
	
	/***********************/
	/*    Private          */
	/***********************/

	private void mergeSort(T[] array, Object[] temp, int first, int last) {
		if (first < last) {
			int mid = (first + last) / 2;
			mergeSort(array, temp, first, mid);
			mergeSort(array, temp, mid+1, last);
			merge(array, temp, first, mid, last);
		}
	}
	
	private void merge(T[] array, Object[] temp, int first, int mid, int last) {
		int first1 = first;
		int last1 = mid;
		int first2 = mid+1;
		int last2 = last;
		
		int index = first1;
		
		
//		showArray(array, first, mid);
//		showArray(array, mid+1, last);
		
		while ((first1 <= last1) && (first2 <= last2)) {
			if (array[first1].compareTo(array[first2]) <= 0) {
				temp[index++] = array[first1++];
			} else {
				temp[index++] = array[first2++];
			}
		}
		
		while (first1 <= last1) {
			temp[index++] = array[first1++];
		}
		
		while (first2 <= last2) {
			temp[index++] = array[first2++];
		}
		
		for (int i = first ; i <= last ; i++ ) {
			array[i] = (T) temp[i];
		}
		
//		showArray(array, first, last);
//		System.out.println("\n\n");
	}
	
//	private void showArray(T[] array, int first, int last) {
//		System.out.print("Array = [");
//		for ( int i = first ; i <= last ; i++ ) {
//			if (i == last) {
//				System.out.print(array[i]);
//			} else {
//				System.out.print(array[i] + ", ");
//			}
//		}
//		System.out.println("]");
//	}
	
	/***********************/
	/*      main           */
	/***********************/
	
	public static void main(String[] args) {
		Integer[] array = {5, 17, 22, 4, 18, 40, 72, 15, 90, 45, 19};
		
		MergeSort<Integer> ms = new MergeSort<Integer>();
		ms.sort(array);
	}
	
}
